
const addBlock = async (api, io, header, status) => {
          const id = Number(header.number)
        const exists = await Block.findByPk(id)
        if (exists) return
        const timestamp = (await api.query.timestamp.now()).toNumber()
                                     const last = await Block.findByPk(id - 1)
                                               
						 const blocktime = last ? timestamp - last.timestamp : 6000
                                               const author = 	header.author?.toString()
 			                                         
        const block = await Block.create({          id,
          timestamp,
          blocktime,
          author
        })
        console.log(
          '[Joystream] block',
          block.id,
          block.blocktime,
          block.author
        )
        io.emit('block', block)

						 update() 
}

const processEvents = (blockHash) => {
          const blockEvents = api.query.system.events.at(
            blockHash
          ) as Vec<EventRecord>
          let transfers = blockEvents.filter((event) => {
            return event.section == 'balances' && event.method == 'Transfer'
          })
          let validatorRewards = blockEvents.filter((event) => {
            return event.section == 'staking' && event.method == 'Reward'
          })
}


const update = () => {
const id = header.number.toNumber();
        if (blocks.find((b) => b.id === id)) return;
        const timestamp = (await api.query.timestamp.now()).toNumber();
        const duration = timestamp - lastBlock.timestamp;
        const block: Block = { id, timestamp, duration };
        blocks = blocks.concat(block);
        this.setState({ blocks, loading: false });
        this.save("block", id);
        this.save("now", timestamp);

        const proposalCount = await get.proposalCount(api);
        if (proposalCount > this.state.proposalCount) {
          this.fetchProposal(api, proposalCount);
          this.setState({ proposalCount });
        }

        const currentChannel = await get.currentChannelId(api);
        if (currentChannel > lastChannel)
          lastChannel = await this.fetchChannels(api, currentChannel);

        const currentCategory = await get.currentCategoryId(api);
        if (currentCategory > lastCategory)
          lastCategory = await this.fetchCategories(api, currentCategory);

        const currentPost = await get.currentPostId(api);
        if (currentPost > lastPost)
          lastPost = await this.fetchPosts(api, currentPost);

        const currentThread = await get.currentThreadId(api);
        if (currentThread > lastThread)
          lastThread = await this.fetchThreads(api, currentThread);

        const postCount = await api.query.proposalsDiscussion.postCount();
        this.setState({ proposalComments: Number(postCount) });

        lastBlock = block;

        // validators
        const currentEra = Number(await api.query.staking.currentEra());
        if (currentEra > era) {
          era = currentEra;
          this.fetchStakes(api, era, this.state.validators);
          this.save("era", era);
          this.fetchLastReward(api, era - 1);
        } else if (this.state.lastReward === 0)
          this.fetchLastReward(api, currentEra);

        this.fetchEraRewardPoints(api, Number(era));

        // check election stage
        if (id < termEndsAt || id < stageEndsAt) return;
        const json = stage.toJSON();
        const key = Object.keys(json)[0];
        stageEndsAt = json[key];
        //console.log(id, stageEndsAt, json, key);

        termEndsAt = Number((await api.query.council.termEndsAt()).toJSON());
        round = Number((await api.query.councilElection.round()).toJSON());
        stage = await api.query.councilElection.stage();
        councilElection = { termEndsAt, stage: stage.toJSON(), round };
        this.setState({ councilElection });

}
